<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card class="q-dialog-plugin">
      <q-card-section>
        <div
          class="text-h5 text-weight-bolder text-grey-9 q-pb-sm"
          v-text="'Comentário'"
        />
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-sm">
          <q-input
            v-model="value.comment"
            class="col-12"
            label="Descrição"
            color="primary"
            bottom-slots
            autogrow
            outlined
            dense
          />

          <q-select
            v-model="value.category"
            :options="options"
            class="col-12"
            label="Categoria"
            color="primary"
            options-cover
            options-dense
            bottom-slots
            map-options
            emit-value
            outlined
            dense
            :error="$v.value.category.$error"
          >
            <template v-slot:option="scope">
              <q-item
                v-bind="scope.itemProps"
                v-on="scope.itemEvents"
              >
                <q-item-section>
                  <div
                    :style="`color: ${scope.opt.color}`"
                    v-text="scope.opt.label"
                  />
                </q-item-section>
              </q-item>
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages($v.value.category)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-select>
        </q-form>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          class="q-mr-sm q-mb-sm"
          color="primary"
          label="OK"
          @click="save"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required } from 'vuelidate/lib/validators'

export default {
  name: 'Comment',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      required: true
    },
    options: {
      type: Array,
      required: true
    }
  },
  validations: {
    value: {
      category: {
        required
      }
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    save () {
      this.$v.value.$touch()

      if (this.$v.value.$error) {
        return undefined
      }

      this.$emit('ok', this.value)
      this.hide()
    }
  }
}
</script>
